<?php
/**
* @fichier: plug.php
* @version: MyPlugBox V1.0.1
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
* Author: Donnie Adams (pluggingit.com)
* @adapter: PatMax - http://www.patmax.info
**/

error_reporting(E_ALL ^ E_NOTICE);// Production
// error_reporting(E_ALL);// Development
// set_magic_quotes_runtime(0);
$pb_paths['root']      = str_replace('\\', '/', dirname(__FILE__)) . '/';
$pb_paths['plug_db']   = $pb_paths['root'] . 'plugs.txt';
$pb_paths['banned_db'] = $pb_paths['root'] . 'banned.txt';
$pb_paths['config_db'] = $pb_paths['root'] . 'config.php';

require_once($pb_paths['config_db']);

switch ((empty($_REQUEST['act']) ? '' : $_REQUEST['act']))
{
	// Redirect to plugger/s web site
	case 'go':
	if (!empty($_GET['id']) && is_numeric($_GET['id']))
	{
		// Find plug and update click count
		if ($plugs = @file($pb_paths['plug_db']))
		{
			$token = '|' . intval($_GET['id']);
			foreach ($plugs as $key => $plug)
			{
				if (strpos($plug, $token) !== false)
				{
					$plug			= explode('|', $plug);
					$plug[2]		= $plug[2] + 1;
					$plugs[$key]	= implode('|', $plug);
					// Write plugs with updated click count to file.
					$plugs = implode('', $plugs);
					ignore_user_abort(true);
					if ($fp = @fopen($pb_paths['plug_db'], 'wb'))
					{
						@flock($fp, LOCK_EX);
						$bytes = fwrite($fp, $plugs, strlen($plugs));
						@flock($fp, LOCK_UN);
						fclose($fp);
					}
					ignore_user_abort(false);
					if (strpos($_SERVER['SERVER_SOFTWARE'], 'Microsoft-IIS') === false)
					{
						header('Location: http://' . $plug[1]);
					}
					else
					{
						header('Refresh: 0; http://' . $plug[1]);
					}
					exit();
					break;
				}
			}
			die('<strong>Redirection Failed</strong>: L\'ID n\'existe pas dans la base de données.');
		}
		$filename = basename($pb_paths['plug_db']);
		die("<strong>Redirection Failed</strong>: Le fichier <em>{$filename}</em> n\'existe pas dans la base de données ou n\'est pas lisible.");
	}
	die('<strong>Redirection Failed</strong>: Caractère d\'ID invalide.');
	break;

  // Add plugs to database
	case 'add':
	// Print Plugboard User Errors
	function pb_print_error($message)
	{
		global $pb_cfg;
		exit(
		str_replace(
		array(
		'{ERROR_MESSAGE}',
		'{BASE_URL}',
		'{WEBSITE_URL}',
		'{IP_ADDRESS}',	),
		array(
		$message,
		$pb_cfg['base_url'],
		$pb_cfg['site_url'],
		$_SERVER['REMOTE_ADDR']	),
		$pb_cfg['error_tpl'] ));
	}

	// Validate a HTTP URL
	function pb_is_valid_url($url)
	{
		$url_regex = "|^(http:\/\/)?(([a-z0-9\-]+\.)+[a-z]{2,6})([^\s\w]([\w$-.+~!*'()@:?=&/;#])*)?$|i";
		return preg_match($url_regex, $url) ? true : false;
	}

	// Validate a button URL
	function pb_is_valid_button($img_url)
	{
		$valid_extentions = array('gif', 'jpg', 'jpeg', 'png', 'bmp', 'php');
		if ( in_array(substr(strrchr($img_url, '.'), 1), $valid_extentions) )
		{
			if (pb_is_valid_url($img_url))
			{
				return true;
			}
		}
			return false;
	}
	// Format, encode, & remove redundancies
	function format_url($url)
	{
		$url = str_replace(array('http://', ''), '', $url);
		$url = htmlspecialchars(utf8_decode($url), ENT_QUOTES);
		return rtrim($url, '/');
	}

	// Has the plugger's IP address been banned?
	if ($ip_bans = @file($pb_paths['banned_db']))
	{
		foreach ($ip_bans as $val)
		{
			if (rtrim($val) == $_SERVER['REMOTE_ADDR'])
			{
				pb_print_error('Vous avez été interdits de connexion sur ce tableau.');
			}
		}
		unset($ip_bans);
	}

	// Initiate variables
	$button_url  = empty($_POST['button_url']) ? '' : trim($_POST['button_url']);
	$website_url = empty($_POST['website_url']) ? '' : trim($_POST['website_url']);
	if (get_magic_quotes_gpc())
	{
		$button_url  = stripslashes($button_url);
		$website_url = stripslashes($website_url);
	}
	$button_url  = format_url($button_url);
	$website_url = format_url($website_url);

	// Flood control
	if ($plugs = @file($pb_paths['plug_db']))
	{
  	$out_of_range = false;
		$now = time();
		foreach ($plugs as $key => $val)
		{
			$val = explode('|', rtrim($val));
			if (!$out_of_range)
			{
				if (($now - $val[4]) < $pb_cfg['timeout'])
				{
					if (strpos($plugs[$key], ('|' . $_SERVER['REMOTE_ADDR'])))
					{
						pb_print_error("Désolé, ce tableau permet seulement une nouvelle inscription, une fois chaque {$pb_cfg['timeout']} secondes.");
					}
				}
				else
				{
					$out_of_range = true;
				}
			}
			if ( ! $pb_cfg['allow_milti_post'])
			{
				if ($val[3] == $_SERVER['REMOTE_ADDR'])
				{
					pb_print_error('Vous ne pouvez pas plusieurs fois.');
				}
			}
			if (($website_url === $val[1]) || ($button_url === $val[0]))
			{
				pb_print_error('Vous ne pouvez pas inscrire le même bouton ou site Web deux fois.');
			}
		}
	}

	// URL validation
	// Button URL validation
	if ( ! pb_is_valid_button($button_url))
	{
		pb_print_error('Vous devez écrire une URL de bouton valide.');
	}
	// Web site URL validation
	if ( ! pb_is_valid_url($website_url))
	{
		pb_print_error('Vous devez écrire une URL de site valide.');
	}

	// Add plug to database
	$plugs = array_merge(
	array("{$button_url}|{$website_url}|0|{$_SERVER['REMOTE_ADDR']}|".time()."\n"),
  (array)$plugs);
	if (sizeof($plugs) > $pb_cfg['max_plugs'])
	{
		$plugs = array_slice($plugs, 0, $pb_cfg['max_plugs']);
	}
	ignore_user_abort(true);
	if ($fp = @fopen($pb_paths['plug_db'], 'wb'))
	{
		$plugs = implode('', $plugs);
		@flock($fp, LOCK_EX);
		$result = fwrite($fp, $plugs, strlen($plugs));
		@flock($fp, LOCK_UN);
		fclose($fp);
	}
	unset($plugs);
	ignore_user_abort(false);
	if (strpos($_SERVER['SERVER_SOFTWARE'], 'Microsoft-IIS') === false)
	{
		header('Location: ' . $pb_cfg['site_url']);
	}
	else
	{
		header('Refresh: 0; ' . $pb_cfg['site_url']);
	}
	exit();
	break;

	// Print plugs to web browser
	default:
	if ($plugs = @file($pb_paths['plug_db']))
	{
		$plug_count = count($plugs);
		if ($pb_cfg['max_plugs'] < $plug_count)
		{
				$plugs = array_slice($plugs, 0, (int)$pb_cfg['max_plugs']);
		}
		if ($plug_count > 1)
		{
			switch (strtoupper($pb_cfg['display_order']))
			{
				case 'RANDOM':
				shuffle($plugs);
				break;
				case 'ASC':
				$plugs = array_reverse($plugs);
				break;
		  }
    }
	}
?>
<? include ("header.html"); ?>
	<table class="forumline" width="100%" cellspacing="0" cellpadding="0" border="0">
		<tr>
			<td class="row1" width="100%" align="left">
				Ce système (nommé Plugboard) permet d'accroitre le nombre de visiteurs de votre site, forum ou page web.<br/><br />
	      <b>Comment faire ?</b><br />
				Il vous suffit d'incrire l'adresse de votre bannière (dimensions 88x31) et l'adresse de votre site, de votre forum ou de votre page web
	      dans la barre ci-dessous.<br /><br />
	      <b>Comment cela fonctionne ?</b><br />
	      Le dernier inscrit déloge le premier. <br />
	      Il faut donc vous réinscrire afin de rester présent le plus longtemps possible sur Le Plugboard.<br />
	      N'hésitez donc pas à passer régulièrement voir si votre bannière est toujours présente.<br /><br />
	      Par contre les pubs menant vers des sites, forums ou pages web ne respectant pas les règles du forum seront supprimées. <br /><br />
	      <br /><br />
	    </td>
	  </tr>
	</table>
	<br />

	<table class="forumline" width="100%" cellspacing="0" cellpadding="0" border="0">
		<tr>
			<td class="row1" width="100%" align="center">
				<form method="post" id="plugform" name="plugform" action="<?php echo $pb_cfg['base_url']; ?>plug.php?act=add">
  				<input type="text" name="button_url" value="Url du Bouton" size="40" title="Url du Bouton" onFocus="if(this.value==this.defaultValue)value=''" onBlur="if(this.value=='')value=this.defaultValue;" />
  				<input type="text" name="website_url" value="Adresse du Site" size="40" title="Adresse du Site" onFocus="if(this.value==this.defaultValue)value=''" onBlur="if(this.value=='')value=this.defaultValue;" />
  				<input type="submit" class="mainoption" name="submit" value="Valider" />
				</form>
				<br /><br />
				<form method="post" id="plugform" name="plugform" action="<?php	echo htmlspecialchars($pb_cfg['site_url'], ENT_QUOTES); ?>">
  				<input type="submit" class="mainoption" name="submit" value="Retour sur le Site" /></p>
				</form>
      </td>
    </tr>
  </table>
	<br clear="all" />

<?php
 	unset($plugs, $pb_cfg);
}
?>
<? include ("footer.html"); ?>

